/* LCM Test Program */
#include <stdio.h>
#include <unistd.h>
//#include <asm/io.h>	//for 2.4 before
#include <sys/io.h>	//for 2.6 before
#include <string.h>
#include <stdlib.h>
#include "lib93304.h"

#define	ON	    1
#define	OFF	    0
#define	RIGHT	    1
#define	LEFT	    0
#define ICON0	    0	//default ICON "up arrow"   04H,0EH,15H,04H,04H,04H,00H,00H
#define ICON1	    1	//default ICON "down arrow" 00H,04H,04H,04H,15H,0EH,04H,00H
#define ICON2	    2	//default ICON "tick"	    00H,01H,02H,02H,04H,14H,08H,00H
#define ICON3	    3	//default ICON "heart"	    00H,0AH,1FH,1FH,0EH,04H,00H,00H
#define ICON4	    4	//default ICON "diamond"    00H,04H,0EH,1FH,0EH,04H,00H,00H
#define ICON5	    5	//default none
#define ICON6	    6	//default none
#define ICON7	    7	//default none
#define	BLON	    0xFB
#define	BLOFF	    0xFC
#define	KEYSTATUS   0xFD
#define	CMD	    0xFE
#define	ESC	    0xFF

char SW1[]="[SW1]";	//You can modified it like 
char SW2[]="[SW2]";	//like Enter/ESC/UP/DOWN/LEFT/RIGHT,
char SW3[]="[SW3]";	//just depends on your machine
char SW4[]="[SW4]";	//
char pixel1[8]={0x00,0x0E,0x11,0x15,0x11,0x0E,0x00,0x00};
char pixel2[8]={0x00,0x0A,0x15,0x11,0x0A,0x04,0x00,0x00};
char pixel3[8]={0x00,0x04,0x0A,0x11,0x0A,0x04,0x00,0x00};
/************************************** LCM Control Function **************************************/
/* Use "0x20" to clear LCM */
void clrs() {
    _Tx_data(CMD);
    _Tx_data(0x01);
}

/* Home Cursor */
void home() {
    _Tx_data(CMD);
    _Tx_data(0x02);
}

/* LCM Backlight on/off */
void bl_test() {
    usleep(1000000);
    _Tx_data(BLOFF);
    usleep(1000000);
    _Tx_data(BLON);
}
/* LCM Display Off */
void display(int display, int cursor, int blink) {
    _Tx_data(CMD);
    if(display==0) { 
	//If Display off ,cursor/blink setting are pointless
	/*
	if(cursor==0) {
	    if(blink==0) _Tx_data(0x08);
	    else _Tx_data(0x09);
	}
	else {
	    if(blink==0) _Tx_data(0x0A);
	    else _Tx_data(0x0B);
	}
	*/
	_Tx_data(0x08);
    }
    else {
	if(cursor==0) {
	    if(blink==0) _Tx_data(0x0C);
	    else _Tx_data(0x0D);
	}
	else {
	    if(blink==0) _Tx_data(0x0E);
	    else _Tx_data(0x0F);
	}
    }
}

/* Cursor or Display Shift */
void display_shift(int LR) {
    if(LR==0) {	//Shift all the display to the left, cursor moves according to the display
	_Tx_data(CMD);
	_Tx_data(0x18);
    }
    else {	//Shift all the display to the right, cursor moves according to the display
	_Tx_data(CMD);
	_Tx_data(0x1C);
    }
}

void cursor_shift(int LR) {
    if(LR==0) {	//Shift cursor to the left, AC is decreased by 1
	_Tx_data(CMD);
	_Tx_data(0x10);
    }
    else {	//Shift cursor to the right, AC is increased by 1
	_Tx_data(CMD);
	_Tx_data(0x14);
    }
}

/* Customize ICON 0~7 */
void customize(int icon, char *pixel) {
    int i;
    _Tx_data(CMD);
    _Tx_data(0x40+(icon*8));

    for(i=0; i<8; i++)
	_Tx_data(*(pixel+i));
    _Tx_data(CMD);
    _Tx_data(ESC);

}

/* Set Cursor Position */
void set_cursorp(int line, int pos) {	//line=1,2  pos=1~40  LCM display only can show 2Line x 16char
    _Tx_data(CMD);
    _Tx_data(0x80+(pos-1)+((line-1)*0x40));
}
/************************************** LCM Control Function **************************************/

/**************************************************************************************************/
char get_keystatus() {
    char ch;
    _Tx_data(KEYSTATUS);
    ch=_Rx_key();
    return ch;
}

int postMsg(char *line1, char *line2) {
    int i;
    int err=0;

    for(i=0; i<strlen(line1); i++) {   //Post Message to LCM 1st Line
	err=_Tx_data(*(line1+i));
	if(err==1) return err;
    }

    for(i=0; i<(40-strlen(line1)); i++) {   //Post space to LCM 1st Line
	err=_Tx_data(0x20);
	if(err==1) return err;
    }

    for(i=0; i<strlen(line2); i++) {   //Post Message to LCM 2nd Line
	err=_Tx_data(*(line2+i));
	if(err==1) return err;
    }

    for(i=0; i<(40-strlen(line2)); i++) {   //Post space to LCM 1st Line
	err=_Tx_data(0x20);
	if(err==1) return err;
    }

    return err;
}

void simple() {
    char ch;
    int done=1, b1=0, b2=0, b3=0, b4=0;
    postMsg("SW1[ ] || SW2[ ]", "SW3[ ] || SW4[ ]"); 
    while(done) {
	ch=_Rx_key();
	switch(ch) {
	    case 'N':
		set_cursorp(1, 5); 
		_Tx_data(ESC); 
		_Tx_data(0xFF); 
		b1=1;
		break;
	    case 'M':
		set_cursorp(1, 15); 
		_Tx_data(ESC); 
		_Tx_data(0xFF); 
		b2=1;
		break;
	    case 'K':
		set_cursorp(2, 5); 
		_Tx_data(ESC); 
		_Tx_data(0xFF); 
		b3=1;
		break;
	    case 'G':
		set_cursorp(2, 15); 
		_Tx_data(ESC); 
		_Tx_data(0xFF); 
		b4=1;
		break;
	}
	if((b1+b2+b3+b4) > 3) done--;
    }
    usleep(500000);
    home();
    postMsg("   KeyPad  OK   ", "Quit the program"); 
}

void fulldemo() {
    int k;
    clrs(); //clear LCM
    home();
    postMsg("Hello World!  ", "    Hello World!"); 
    printf("Display ON/OFF ..................[done]\n\n");
    for(k=0; k<3; k++) {
	display(OFF, OFF, OFF);
	usleep(500000);
	display(ON, OFF, OFF);
	usleep(500000);
    }
    printf("Backlight ON/OFF ...............[done]\n\n");
    for(k=0; k<3; k++) {
	bl_test();
    }
    printf("Display Shift ...................[done]\n\n");
    for(k=0; k<5; k++) {
	display_shift(RIGHT);
	usleep(500000);
    }
    for(k=0; k<5; k++) {
	display_shift(LEFT);
	usleep(500000);
    }
    display(ON, ON, OFF);
    usleep(500000);
    printf("Cursor  Shift ...................[done]\n\n");
    for(k=0; k<16; k++) {
	cursor_shift(RIGHT);
	usleep(400000);
    }
    set_cursorp(2,16);
    usleep(400000);
    for(k=0; k<16; k++) {
	cursor_shift(LEFT);
	usleep(400000);
    }
    display(ON, ON, ON);
    usleep(500000);
    printf("Cursor & Blink Shift ............[done]\n\n");
    for(k=0; k<16; k++) {
	cursor_shift(RIGHT);
	usleep(400000);
    }
    set_cursorp(1,16);
    usleep(400000);
    for(k=0; k<16; k++) {
	cursor_shift(LEFT);
	usleep(400000);
    }
    display(ON, OFF, OFF);
    usleep(500000);
    printf("Customize ICON ..................[done]\n\n");
    //ICON0 ~ ICON4 also can modified, while LCM Reset it return to default value
    customize(ICON5, pixel1);
    customize(ICON6, pixel2);
    customize(ICON7, pixel3);

    printf("Show Customize ICON .............[done]\n\n");
    clrs();
    set_cursorp(1,5);
    _Tx_data(ICON0);
    _Tx_data(ICON1);
    _Tx_data(ICON2);
    _Tx_data(ICON3);
    _Tx_data(ICON4);
    _Tx_data(ICON5);
    _Tx_data(ICON6);
    _Tx_data(ICON7);
    usleep(1000000);
    set_cursorp(2,5);
    _Tx_data(ICON0);
    _Tx_data(ICON1);
    _Tx_data(ICON2);
    _Tx_data(ICON3);
    _Tx_data(ICON4);
    _Tx_data(ICON5);
    _Tx_data(ICON6);
    _Tx_data(ICON7);
}

/**************************************************************************************************/
int main(int argc, char **argv) {
    char msg1[]="    Axiomtek    ";
    char msg2[]="Network Appliance Platform";

    int coom=2; //default com 2
    int i, lock=1;
    char ch;


    i=_init_com(coom,9600,8,1,0); //init serial port by 9600,N,8,1

    switch(i){
	case 1:
	    printf("Com error!\n");
	    break;
	case 5:
	    printf("Baud error!\n");
	    break;
	case 2:
	    printf("Data  Bit error!\n");
	    break;
	case 3:
	    printf("Stop Bit error!\n");
	    break;
	case 4:
	    printf("Parity error!\n");
	    break;
	case 0:
	default:
	    printf("Init OK!!!\n");
	    break;
    }

    for(i=0; i<10; i++) _Rx_key(); //Clear keypad buffer

    clrs(); //clear LCM
    home(); //home cursor
    postMsg(msg1, msg2); //Init LCM and show company LOGO

    usleep(1000000);
    system("clear");
    
    printf("************ Function Key *************\n");
    printf("*   [SW1] => Show Hello world on LCM  *\n");
    printf("*   [SW2] => Simple keypad testing    *\n");
    printf("*   [SW3] => Full LCM Function Demo   *\n");
    printf("*   [SW4] => Quit the program         *\n");
    printf("***************************************\n");

    do {
//	ch=get_keystatus();
	ch=_Rx_key();
	switch(ch) {
	    case 'N':
		clrs(); //clear LCM
		home();
		postMsg("Hello World  ", "    Hello World"); 
		lock--;
		break;
	    case 'M':
		simple();
		lock--;
		break;
	    case 'K':
		fulldemo();
		lock--;
		break;
	    case 'G':
		lock--;
		break;
	}
    } while(lock);
    return 0;
}//main
